/[gentoo-x86]/eclass/linux-info.eclass
Gentoo

Diff of /eclass/linux-info.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.56 Revision 1.91
1# Copyright 1999-2006 Gentoo Foundation 1# Copyright 1999-2011 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.56 2008/10/31 22:01:32 dsd Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/linux-info.eclass,v 1.91 2011/12/12 22:01:37 vapier Exp $
4#
5# Original author: John Mylchreest <johnm@gentoo.org>
6# Maintainer: kernel-misc@gentoo.org
7#
8# Please direct your bugs to the current eclass maintainer :)
9 4
10# @ECLASS: linux-info.eclass 5# @ECLASS: linux-info.eclass
11# @MAINTAINER: 6# @MAINTAINER:
12# kernel-misc@gentoo.org 7# kernel-misc@gentoo.org
8# @AUTHOR:
9# Original author: John Mylchreest <johnm@gentoo.org>
13# @BLURB: eclass used for accessing kernel related information 10# @BLURB: eclass used for accessing kernel related information
14# @DESCRIPTION: 11# @DESCRIPTION:
15# This eclass is used as a central eclass for accessing kernel 12# This eclass is used as a central eclass for accessing kernel
16# related information for sources already installed. 13# related information for source or binary already installed.
17# It is vital for linux-mod.eclass to function correctly, and is split 14# It is vital for linux-mod.eclass to function correctly, and is split
18# out so that any ebuild behaviour "templates" are abstracted out 15# out so that any ebuild behaviour "templates" are abstracted out
19# using additional eclasses. 16# using additional eclasses.
17#
18# "kernel config" in this file means:
19# The .config of the currently installed sources is used as the first
20# preference, with a fall-back to bundled config (/proc/config.gz) if available.
20 21
21# A Couple of env vars are available to effect usage of this eclass 22# A Couple of env vars are available to effect usage of this eclass
22# These are as follows: 23# These are as follows:
23 24
24# @ECLASS-VARIABLE: KERNEL_DIR 25# @ECLASS-VARIABLE: KERNEL_DIR
37# prepending it with an exclamation mark (!). 38# prepending it with an exclamation mark (!).
38# 39#
39# e.g.: CONFIG_CHECK="!MTRR" 40# e.g.: CONFIG_CHECK="!MTRR"
40# 41#
41# To simply warn about a missing option, prepend a '~'. 42# To simply warn about a missing option, prepend a '~'.
43# It may be combined with '!'.
44#
45# In general, most checks should be non-fatal. The only time fatal checks should
46# be used is for building kernel modules or cases that a compile will fail
47# without the option.
48#
49# This is to allow usage of binary kernels, and minimal systems without kernel
50# sources.
42 51
43# @ECLASS-VARIABLE: ERROR_<CFG> 52# @ECLASS-VARIABLE: ERROR_<CFG>
44# @DESCRIPTION: 53# @DESCRIPTION:
45# A string containing the error message to display when the check against CONFIG_CHECK 54# A string containing the error message to display when the check against CONFIG_CHECK
46# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK. 55# fails. <CFG> should reference the appropriate option used in CONFIG_CHECK.
92# And to ensure all the weirdness with crosscompile 101# And to ensure all the weirdness with crosscompile
93inherit toolchain-funcs versionator 102inherit toolchain-funcs versionator
94 103
95EXPORT_FUNCTIONS pkg_setup 104EXPORT_FUNCTIONS pkg_setup
96 105
97DEPEND="kernel_linux? ( virtual/linux-sources )" 106DEPEND=""
98RDEPEND="" 107RDEPEND=""
99 108
100# Overwritable environment Var's 109# Overwritable environment Var's
101# --------------------------------------- 110# ---------------------------------------
102KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}" 111KERNEL_DIR="${KERNEL_DIR:-${ROOT}usr/src/linux}"
134 esac 143 esac
135 [ -n "${outputmsg}" ] && ${type} "${outputmsg}" 144 [ -n "${outputmsg}" ] && ${type} "${outputmsg}"
136} 145}
137 146
138qeinfo() { qout einfo "${@}" ; } 147qeinfo() { qout einfo "${@}" ; }
148qewarn() { qout ewarn "${@}" ; }
139qeerror() { qout eerror "${@}" ; } 149qeerror() { qout eerror "${@}" ; }
140 150
141# File Functions 151# File Functions
142# --------------------------------------- 152# ---------------------------------------
143 153
144# @FUNCTION: getfilevar 154# @FUNCTION: getfilevar
145# @USAGE: variable configfile 155# @USAGE: variable configfile
146# @RETURN: the value of the variable 156# @RETURN: the value of the variable
147# @DESCRIPTION: 157# @DESCRIPTION:
148# It detects the value of the variable defined in the file configfile 158# It detects the value of the variable defined in the file configfile. This is
159# done by including the configfile, and printing the variable with Make.
160# It WILL break if your makefile has missing dependencies!
149getfilevar() { 161getfilevar() {
150local ERROR workingdir basefname basedname myARCH="${ARCH}" 162local ERROR basefname basedname myARCH="${ARCH}"
151 ERROR=0 163 ERROR=0
152 164
153 [ -z "${1}" ] && ERROR=1 165 [ -z "${1}" ] && ERROR=1
154 [ ! -f "${2}" ] && ERROR=1 166 [ ! -f "${2}" ] && ERROR=1
155 167
157 then 169 then
158 echo -e "\n" 170 echo -e "\n"
159 eerror "getfilevar requires 2 variables, with the second a valid file." 171 eerror "getfilevar requires 2 variables, with the second a valid file."
160 eerror " getfilevar <VARIABLE> <CONFIGFILE>" 172 eerror " getfilevar <VARIABLE> <CONFIGFILE>"
161 else 173 else
162 workingdir="${PWD}"
163 basefname="$(basename ${2})" 174 basefname="$(basename ${2})"
164 basedname="$(dirname ${2})" 175 basedname="$(dirname ${2})"
165 unset ARCH 176 unset ARCH
166 177
167 cd "${basedname}"
168 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \ 178 echo -e "e:\\n\\t@echo \$(${1})\\ninclude ${basefname}" | \
169 make M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null 179 make -C "${basedname}" M="${S}" ${BUILD_FIXES} -s -f - 2>/dev/null
170 cd "${workingdir}"
171 180
172 ARCH=${myARCH} 181 ARCH=${myARCH}
173 fi 182 fi
174} 183}
175 184
185# @FUNCTION: getfilevar_noexec
186# @USAGE: variable configfile
187# @RETURN: the value of the variable
188# @DESCRIPTION:
189# It detects the value of the variable defined in the file configfile.
190# This is done with sed matching an expression only. If the variable is defined,
191# you will run into problems. See getfilevar for those cases.
192getfilevar_noexec() {
193 local ERROR basefname basedname mycat myARCH="${ARCH}"
194 ERROR=0
195 mycat='cat'
196
197 [ -z "${1}" ] && ERROR=1
198 [ ! -f "${2}" ] && ERROR=1
199 [ "${2%.gz}" != "${2}" ] && mycat='zcat'
200
201 if [ "${ERROR}" = 1 ]
202 then
203 echo -e "\n"
204 eerror "getfilevar_noexec requires 2 variables, with the second a valid file."
205 eerror " getfilevar_noexec <VARIABLE> <CONFIGFILE>"
206 else
207 ${mycat} "${2}" | \
208 sed -n \
209 -e "/^[[:space:]]*${1}[[:space:]]*:\\?=[[:space:]]*\(.*\)\$/{
210 s,^[^=]*[[:space:]]*=[[:space:]]*,,g ;
211 s,[[:space:]]*\$,,g ;
212 p
213 }"
214 fi
215}
216
217# @ECLASS-VARIABLE: _LINUX_CONFIG_EXISTS_DONE
218# @INTERNAL
219# @DESCRIPTION:
220# This is only set if one of the linux_config_*exists functions has been called.
221# We use it for a QA warning that the check for a config has not been performed,
222# as linux_chkconfig* in non-legacy mode WILL return an undefined value if no
223# config is available at all.
224_LINUX_CONFIG_EXISTS_DONE=
225
226linux_config_qa_check() {
227 local f="$1"
228 if [ -z "${_LINUX_CONFIG_EXISTS_DONE}" ]; then
229 ewarn "QA: You called $f before any linux_config_exists!"
230 ewarn "QA: The return value of $f will NOT guaranteed later!"
231 fi
232}
233
234# @FUNCTION: linux_config_src_exists
235# @RETURN: true or false
236# @DESCRIPTION:
237# It returns true if .config exists in a build directory otherwise false
238linux_config_src_exists() {
239 export _LINUX_CONFIG_EXISTS_DONE=1
240 [ -s "${KV_OUT_DIR}/.config" ]
241}
242
243# @FUNCTION: linux_config_bin_exists
244# @RETURN: true or false
245# @DESCRIPTION:
246# It returns true if .config exists in /proc, otherwise false
247linux_config_bin_exists() {
248 export _LINUX_CONFIG_EXISTS_DONE=1
249 [ -s "/proc/config.gz" ]
250}
176 251
177# @FUNCTION: linux_config_exists 252# @FUNCTION: linux_config_exists
178# @RETURN: true or false 253# @RETURN: true or false
179# @DESCRIPTION: 254# @DESCRIPTION:
180# It returns true if .config exists otherwise false 255# It returns true if .config exists otherwise false
256#
257# This function MUST be checked before using any of the linux_chkconfig_*
258# functions.
181linux_config_exists() { 259linux_config_exists() {
182 [ -s "${KV_OUT_DIR}/.config" ] 260 linux_config_src_exists || linux_config_bin_exists
183} 261}
184 262
185# @FUNCTION: require_configured_kernel 263# @FUNCTION: require_configured_kernel
186# @DESCRIPTION: 264# @DESCRIPTION:
187# This function verifies that the current kernel is configured (it checks against the existence of .config) 265# This function verifies that the current kernel is configured (it checks against the existence of .config)
188# otherwise it dies. 266# otherwise it dies.
189require_configured_kernel() { 267require_configured_kernel() {
190 if ! linux_config_exists; then 268 if ! linux_config_src_exists; then
191 qeerror "Could not find a usable .config in the kernel source directory." 269 qeerror "Could not find a usable .config in the kernel source directory."
192 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources." 270 qeerror "Please ensure that ${KERNEL_DIR} points to a configured set of Linux sources."
193 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that" 271 qeerror "If you are using KBUILD_OUTPUT, please set the environment var so that"
194 qeerror "it points to the necessary object directory so that it might find .config." 272 qeerror "it points to the necessary object directory so that it might find .config."
195 die "Kernel not configured; no .config found in ${KV_OUT_DIR}" 273 die "Kernel not configured; no .config found in ${KV_OUT_DIR}"
198 276
199# @FUNCTION: linux_chkconfig_present 277# @FUNCTION: linux_chkconfig_present
200# @USAGE: option 278# @USAGE: option
201# @RETURN: true or false 279# @RETURN: true or false
202# @DESCRIPTION: 280# @DESCRIPTION:
203# It checks that CONFIG_<option>=y or CONFIG_<option>=n is present in the current kernel .config 281# It checks that CONFIG_<option>=y or CONFIG_<option>=m is present in the current kernel .config
282# If linux_config_exists returns false, the results of this are UNDEFINED. You
283# MUST call linux_config_exists first.
204linux_chkconfig_present() { 284linux_chkconfig_present() {
285 linux_config_qa_check linux_chkconfig_present
205local RESULT 286 local RESULT
206 require_configured_kernel 287 local config
288 config="${KV_OUT_DIR}/.config"
289 [ ! -f "${config}" ] && config="/proc/config.gz"
207 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 290 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
208 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1 291 [ "${RESULT}" = "m" -o "${RESULT}" = "y" ] && return 0 || return 1
209} 292}
210 293
211# @FUNCTION: linux_chkconfig_module 294# @FUNCTION: linux_chkconfig_module
212# @USAGE: option 295# @USAGE: option
213# @RETURN: true or false 296# @RETURN: true or false
214# @DESCRIPTION: 297# @DESCRIPTION:
215# It checks that CONFIG_<option>=m is present in the current kernel .config 298# It checks that CONFIG_<option>=m is present in the current kernel .config
299# If linux_config_exists returns false, the results of this are UNDEFINED. You
300# MUST call linux_config_exists first.
216linux_chkconfig_module() { 301linux_chkconfig_module() {
302 linux_config_qa_check linux_chkconfig_module
217local RESULT 303 local RESULT
218 require_configured_kernel 304 local config
305 config="${KV_OUT_DIR}/.config"
306 [ ! -f "${config}" ] && config="/proc/config.gz"
219 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 307 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
220 [ "${RESULT}" = "m" ] && return 0 || return 1 308 [ "${RESULT}" = "m" ] && return 0 || return 1
221} 309}
222 310
223# @FUNCTION: linux_chkconfig_builtin 311# @FUNCTION: linux_chkconfig_builtin
224# @USAGE: option 312# @USAGE: option
225# @RETURN: true or false 313# @RETURN: true or false
226# @DESCRIPTION: 314# @DESCRIPTION:
227# It checks that CONFIG_<option>=y is present in the current kernel .config 315# It checks that CONFIG_<option>=y is present in the current kernel .config
316# If linux_config_exists returns false, the results of this are UNDEFINED. You
317# MUST call linux_config_exists first.
228linux_chkconfig_builtin() { 318linux_chkconfig_builtin() {
319 linux_config_qa_check linux_chkconfig_builtin
229local RESULT 320 local RESULT
230 require_configured_kernel 321 local config
322 config="${KV_OUT_DIR}/.config"
323 [ ! -f "${config}" ] && config="/proc/config.gz"
231 RESULT="$(getfilevar CONFIG_${1} ${KV_OUT_DIR}/.config)" 324 RESULT="$(getfilevar_noexec CONFIG_${1} "${config}")"
232 [ "${RESULT}" = "y" ] && return 0 || return 1 325 [ "${RESULT}" = "y" ] && return 0 || return 1
233} 326}
234 327
235# @FUNCTION: linux_chkconfig_string 328# @FUNCTION: linux_chkconfig_string
236# @USAGE: option 329# @USAGE: option
237# @RETURN: CONFIG_<option> 330# @RETURN: CONFIG_<option>
238# @DESCRIPTION: 331# @DESCRIPTION:
239# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel). 332# It prints the CONFIG_<option> value of the current kernel .config (it requires a configured kernel).
333# If linux_config_exists returns false, the results of this are UNDEFINED. You
334# MUST call linux_config_exists first.
240linux_chkconfig_string() { 335linux_chkconfig_string() {
241 require_configured_kernel 336 linux_config_qa_check linux_chkconfig_string
337 local config
338 config="${KV_OUT_DIR}/.config"
339 [ ! -f "${config}" ] && config="/proc/config.gz"
242 getfilevar "CONFIG_${1}" "${KV_OUT_DIR}/.config" 340 getfilevar_noexec "CONFIG_${1}" "${config}"
243} 341}
244 342
245# Versioning Functions 343# Versioning Functions
246# --------------------------------------- 344# ---------------------------------------
247 345
259# kernel_is 2 6 returns true 357# kernel_is 2 6 returns true
260# kernel_is 2 6 8 returns false 358# kernel_is 2 6 8 returns false
261# kernel_is 2 6 9 returns true 359# kernel_is 2 6 9 returns true
262# @CODE 360# @CODE
263 361
264# got the jist yet? 362# Note: duplicated in kernel-2.eclass
265
266kernel_is() { 363kernel_is() {
267 # if we haven't determined the version yet, we need to. 364 # if we haven't determined the version yet, we need to.
268 get_version 365 linux-info_get_any_version
366
367 # Now we can continue
269 local operator test value x=0 y=0 z=0 368 local operator test value
270 369
271 case ${1} in 370 case ${1#-} in
272 lt) operator="-lt"; shift;; 371 lt) operator="-lt"; shift;;
273 gt) operator="-gt"; shift;; 372 gt) operator="-gt"; shift;;
274 le) operator="-le"; shift;; 373 le) operator="-le"; shift;;
275 ge) operator="-ge"; shift;; 374 ge) operator="-ge"; shift;;
276 eq) operator="-eq"; shift;; 375 eq) operator="-eq"; shift;;
277 *) operator="-eq";; 376 *) operator="-eq";;
278 esac 377 esac
279
280 for x in ${@}; do
281 for((y=0; y<$((3 - ${#x})); y++)); do value="${value}0"; done
282 value="${value}${x}"
283 z=$((${z} + 1))
284
285 case ${z} in
286 1) for((y=0; y<$((3 - ${#KV_MAJOR})); y++)); do test="${test}0"; done;
287 test="${test}${KV_MAJOR}";;
288 2) for((y=0; y<$((3 - ${#KV_MINOR})); y++)); do test="${test}0"; done;
289 test="${test}${KV_MINOR}";;
290 3) for((y=0; y<$((3 - ${#KV_PATCH})); y++)); do test="${test}0"; done;
291 test="${test}${KV_PATCH}";;
292 *) die "Error in kernel-2_kernel_is(): Too many parameters.";; 378 [[ $# -gt 3 ]] && die "Error in kernel-2_kernel_is(): too many parameters"
293 esac
294 done
295 379
296 [ ${test} ${operator} ${value} ] && return 0 || return 1 380 : $(( test = (KV_MAJOR << 16) + (KV_MINOR << 8) + KV_PATCH ))
381 : $(( value = (${1:-${KV_MAJOR}} << 16) + (${2:-${KV_MINOR}} << 8) + ${3:-${KV_PATCH}} ))
382 [ ${test} ${operator} ${value} ]
297} 383}
298 384
299get_localversion() { 385get_localversion() {
300 local lv_list i x 386 local lv_list i x
301 387
309 done 395 done
310 x=${x/ /} 396 x=${x/ /}
311 echo ${x} 397 echo ${x}
312} 398}
313 399
400# Check if the Makefile is valid for direct parsing.
401# Check status results:
402# - PASS, use 'getfilevar' to extract values
403# - FAIL, use 'getfilevar_noexec' to extract values
404# The check may fail if:
405# - make is not present
406# - corruption exists in the kernel makefile
407get_makefile_extract_function() {
408 local a='' b='' mkfunc='getfilevar'
409 a="$(getfilevar VERSION ${KERNEL_MAKEFILE})"
410 b="$(getfilevar_noexec VERSION ${KERNEL_MAKEFILE})"
411 [[ "${a}" != "${b}" ]] && mkfunc='getfilevar_noexec'
412 echo "${mkfunc}"
413}
414
415# internal variable, so we know to only print the warning once
416get_version_warning_done=
417
314# @FUNCTION: get_version 418# @FUNCTION: get_version
315# @DESCRIPTION: 419# @DESCRIPTION:
316# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable 420# It gets the version of the kernel inside KERNEL_DIR and populates the KV_FULL variable
317# (if KV_FULL is already set it does nothing). 421# (if KV_FULL is already set it does nothing).
318# 422#
320# 424#
321# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid 425# The KV_DIR is set using the KERNEL_DIR env var, the KV_DIR_OUT is set using a valid
322# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the 426# KBUILD_OUTPUT (in a decreasing priority list, we look for the env var, makefile var or the
323# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build). 427# symlink /lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build).
324get_version() { 428get_version() {
325 local kbuild_output 429 local kbuild_output mkfunc tmplocal
326 430
327 # no need to execute this twice assuming KV_FULL is populated. 431 # no need to execute this twice assuming KV_FULL is populated.
328 # we can force by unsetting KV_FULL 432 # we can force by unsetting KV_FULL
329 [ -n "${KV_FULL}" ] && return 0 433 [ -n "${KV_FULL}" ] && return 0
330 434
331 # if we dont know KV_FULL, then we need too. 435 # if we dont know KV_FULL, then we need too.
332 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR 436 # make sure KV_DIR isnt set since we need to work it out via KERNEL_DIR
333 unset KV_DIR 437 unset KV_DIR
334 438
335 # KV_DIR will contain the full path to the sources directory we should use 439 # KV_DIR will contain the full path to the sources directory we should use
440 [ -z "${get_version_warning_done}" ] && \
336 qeinfo "Determining the location of the kernel source code" 441 qeinfo "Determining the location of the kernel source code"
337 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})" 442 [ -h "${KERNEL_DIR}" ] && KV_DIR="$(readlink -f ${KERNEL_DIR})"
338 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}" 443 [ -d "${KERNEL_DIR}" ] && KV_DIR="${KERNEL_DIR}"
339 444
340 if [ -z "${KV_DIR}" ] 445 if [ -z "${KV_DIR}" ]
341 then 446 then
447 if [ -z "${get_version_warning_done}" ]; then
448 get_version_warning_done=1
342 qeerror "Unable to find kernel sources at ${KERNEL_DIR}" 449 qeerror "Unable to find kernel sources at ${KERNEL_DIR}"
343 qeinfo "This package requires Linux sources." 450 #qeinfo "This package requires Linux sources."
344 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then 451 if [ "${KERNEL_DIR}" == "/usr/src/linux" ] ; then
345 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, " 452 qeinfo "Please make sure that ${KERNEL_DIR} points at your running kernel, "
346 qeinfo "(or the kernel you wish to build against)." 453 qeinfo "(or the kernel you wish to build against)."
347 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location" 454 qeinfo "Alternatively, set the KERNEL_DIR environment variable to the kernel sources location"
348 else 455 else
349 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against." 456 qeinfo "Please ensure that the KERNEL_DIR environment variable points at full Linux sources of the kernel you wish to compile against."
457 fi
350 fi 458 fi
351 return 1 459 return 1
352 fi 460 fi
353 461
462 if [ -z "${get_version_warning_done}" ]; then
354 qeinfo "Found kernel source directory:" 463 qeinfo "Found kernel source directory:"
355 qeinfo " ${KV_DIR}" 464 qeinfo " ${KV_DIR}"
465 fi
356 466
357 if [ ! -s "${KV_DIR}/Makefile" ] 467 if [ ! -s "${KV_DIR}/Makefile" ]
358 then 468 then
469 if [ -z "${get_version_warning_done}" ]; then
470 get_version_warning_done=1
359 qeerror "Could not find a Makefile in the kernel source directory." 471 qeerror "Could not find a Makefile in the kernel source directory."
360 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources" 472 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources"
473 fi
361 return 1 474 return 1
362 fi 475 fi
363 476
364 # OK so now we know our sources directory, but they might be using 477 # OK so now we know our sources directory, but they might be using
365 # KBUILD_OUTPUT, and we need this for .config and localversions-* 478 # KBUILD_OUTPUT, and we need this for .config and localversions-*
366 # so we better find it eh? 479 # so we better find it eh?
367 # do we pass KBUILD_OUTPUT on the CLI? 480 # do we pass KBUILD_OUTPUT on the CLI?
368 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}" 481 OUTPUT_DIR="${OUTPUT_DIR:-${KBUILD_OUTPUT}}"
369 482
483 # keep track of it
484 KERNEL_MAKEFILE="${KV_DIR}/Makefile"
485
486 # Decide the function used to extract makefile variables.
487 mkfunc="$(get_makefile_extract_function "${KERNEL_MAKEFILE}")"
488
370 # And if we didn't pass it, we can take a nosey in the Makefile 489 # And if we didn't pass it, we can take a nosey in the Makefile
371 kbuild_output="$(getfilevar KBUILD_OUTPUT ${KV_DIR}/Makefile)" 490 kbuild_output="$(${mkfunc} KBUILD_OUTPUT ${KERNEL_MAKEFILE})"
372 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}" 491 OUTPUT_DIR="${OUTPUT_DIR:-${kbuild_output}}"
373 492
374 # And contrary to existing functions I feel we shouldn't trust the 493 # And contrary to existing functions I feel we shouldn't trust the
375 # directory name to find version information as this seems insane. 494 # directory name to find version information as this seems insane.
376 # so we parse ${KV_DIR}/Makefile 495 # so we parse ${KERNEL_MAKEFILE}
377 KV_MAJOR="$(getfilevar VERSION ${KV_DIR}/Makefile)" 496 KV_MAJOR="$(${mkfunc} VERSION ${KERNEL_MAKEFILE})"
378 KV_MINOR="$(getfilevar PATCHLEVEL ${KV_DIR}/Makefile)" 497 KV_MINOR="$(${mkfunc} PATCHLEVEL ${KERNEL_MAKEFILE})"
379 KV_PATCH="$(getfilevar SUBLEVEL ${KV_DIR}/Makefile)" 498 KV_PATCH="$(${mkfunc} SUBLEVEL ${KERNEL_MAKEFILE})"
380 KV_EXTRA="$(getfilevar EXTRAVERSION ${KV_DIR}/Makefile)" 499 KV_EXTRA="$(${mkfunc} EXTRAVERSION ${KERNEL_MAKEFILE})"
381 500
382 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ] 501 if [ -z "${KV_MAJOR}" -o -z "${KV_MINOR}" -o -z "${KV_PATCH}" ]
383 then 502 then
503 if [ -z "${get_version_warning_done}" ]; then
504 get_version_warning_done=1
384 qeerror "Could not detect kernel version." 505 qeerror "Could not detect kernel version."
385 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources." 506 qeerror "Please ensure that ${KERNEL_DIR} points to a complete set of Linux sources."
507 fi
386 return 1 508 return 1
387 fi 509 fi
388 510
389 # and in newer versions we can also pull LOCALVERSION if it is set. 511 # and in newer versions we can also pull LOCALVERSION if it is set.
390 # but before we do this, we need to find if we use a different object directory. 512 # but before we do this, we need to find if we use a different object directory.
391 # This *WILL* break if the user is using localversions, but we assume it was 513 # This *WILL* break if the user is using localversions, but we assume it was
392 # caught before this if they are. 514 # caught before this if they are.
393 [ "${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}" == "$(uname -r)" ] && \
394 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}" 515 OUTPUT_DIR="${OUTPUT_DIR:-/lib/modules/${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}/build}"
395 516
396 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})" 517 [ -h "${OUTPUT_DIR}" ] && KV_OUT_DIR="$(readlink -f ${OUTPUT_DIR})"
397 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}" 518 [ -d "${OUTPUT_DIR}" ] && KV_OUT_DIR="${OUTPUT_DIR}"
398 if [ -n "${KV_OUT_DIR}" ]; 519 if [ -n "${KV_OUT_DIR}" ];
399 then 520 then
400 qeinfo "Found kernel object directory:" 521 qeinfo "Found kernel object directory:"
401 qeinfo " ${KV_OUT_DIR}" 522 qeinfo " ${KV_OUT_DIR}"
402
403 KV_LOCAL="$(get_localversion ${KV_OUT_DIR})"
404 fi 523 fi
405 # and if we STILL have not got it, then we better just set it to KV_DIR 524 # and if we STILL have not got it, then we better just set it to KV_DIR
406 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}" 525 KV_OUT_DIR="${KV_OUT_DIR:-${KV_DIR}}"
407 526
408 KV_LOCAL="${KV_LOCAL}$(get_localversion ${KV_DIR})" 527 # Grab the kernel release from the output directory.
409 if linux_config_exists; then 528 # TODO: we MUST detect kernel.release being out of date, and 'return 1' from
410 KV_LOCAL="${KV_LOCAL}$(linux_chkconfig_string LOCALVERSION)" 529 # this function.
411 KV_LOCAL="${KV_LOCAL//\"/}" 530 if [ -s "${KV_OUT_DIR}"/include/config/kernel.release ]; then
531 KV_LOCAL=$(<"${KV_OUT_DIR}"/include/config/kernel.release)
532 elif [ -s "${KV_OUT_DIR}"/.kernelrelease ]; then
533 KV_LOCAL=$(<"${KV_OUT_DIR}"/.kernelrelease)
534 else
535 KV_LOCAL=
536 fi
412 537
413 # For things like git that can append extra stuff: 538 # KV_LOCAL currently contains the full release; discard the first bits.
414 [ -e ${KV_DIR}/scripts/setlocalversion ] && 539 tmplocal=${KV_LOCAL#${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}}
415 linux_chkconfig_builtin LOCALVERSION_AUTO && 540
416 KV_LOCAL="${KV_LOCAL}$(sh ${KV_DIR}/scripts/setlocalversion ${KV_DIR})" 541 # If the updated local version was not changed, the tree is not prepared.
542 # Clear out KV_LOCAL in that case.
543 # TODO: this does not detect a change in the localversion part between
544 # kernel.release and the value that would be generated.
545 if [ "$KV_LOCAL" = "$tmplocal" ]; then
546 KV_LOCAL=
547 else
548 KV_LOCAL=$tmplocal
417 fi 549 fi
418 550
419 # And we should set KV_FULL to the full expanded version 551 # And we should set KV_FULL to the full expanded version
420 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}" 552 KV_FULL="${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}${KV_EXTRA}${KV_LOCAL}"
421 553
430# It gets the version of the current running kernel and the result is the same as get_version() if the 562# It gets the version of the current running kernel and the result is the same as get_version() if the
431# function can find the sources. 563# function can find the sources.
432get_running_version() { 564get_running_version() {
433 KV_FULL=$(uname -r) 565 KV_FULL=$(uname -r)
434 566
567 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile && -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
568 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
569 KBUILD_OUTPUT=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/build)
570 unset KV_FULL
571 get_version
572 return $?
435 if [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then 573 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/source/Makefile ]]; then
436 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source) 574 KERNEL_DIR=$(readlink -f ${ROOT}/lib/modules/${KV_FULL}/source)
437 unset KV_FULL 575 unset KV_FULL
438 get_version 576 get_version
439 return $? 577 return $?
440 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then 578 elif [[ -f ${ROOT}/lib/modules/${KV_FULL}/build/Makefile ]]; then
443 get_version 581 get_version
444 return $? 582 return $?
445 else 583 else
446 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL}) 584 KV_MAJOR=$(get_version_component_range 1 ${KV_FULL})
447 KV_MINOR=$(get_version_component_range 2 ${KV_FULL}) 585 KV_MINOR=$(get_version_component_range 2 ${KV_FULL})
448 KV_PATCH=$(get_version_component_range 3- ${KV_FULL}) 586 KV_PATCH=$(get_version_component_range 3 ${KV_FULL})
449 KV_PATCH=${KV_PATCH//-*} 587 KV_PATCH=${KV_PATCH//-*}
450 [[ -n ${KV_FULL#*-} ]] && [[ -n ${KV_FULL//${KV_FULL#*-}} ]] \ 588 KV_EXTRA="${KV_FULL#${KV_MAJOR}.${KV_MINOR}.${KV_PATCH}}"
451 && KV_EXTRA="-${KV_FULL#*-}"
452 fi 589 fi
453 return 0 590 return 0
591}
592
593# This next function is named with the eclass prefix to avoid conflicts with
594# some old versionator-like eclass functions.
595
596# @FUNCTION: linux-info_get_any_version
597# @DESCRIPTION:
598# This attempts to find the version of the sources, and otherwise falls back to
599# the version of the running kernel.
600linux-info_get_any_version() {
601 get_version
602 if [[ $? -ne 0 ]]; then
603 ewarn "Unable to calculate Linux Kernel version for build, attempting to use running version"
604 get_running_version
605 fi
454} 606}
455 607
456 608
457# ebuild check functions 609# ebuild check functions
458# --------------------------------------- 610# ---------------------------------------
502# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e. 654# It checks the kernel config options specified by CONFIG_CHECK. It dies only when a required config option (i.e.
503# the prefix ~ is not used) doesn't satisfy the directive. 655# the prefix ~ is not used) doesn't satisfy the directive.
504check_extra_config() { 656check_extra_config() {
505 local config negate die error reworkmodulenames 657 local config negate die error reworkmodulenames
506 local soft_errors_count=0 hard_errors_count=0 config_required=0 658 local soft_errors_count=0 hard_errors_count=0 config_required=0
659 # store the value of the QA check, because otherwise we won't catch usages
660 # after if check_extra_config is called AND other direct calls are done
661 # later.
662 local old_LINUX_CONFIG_EXISTS_DONE="${_LINUX_CONFIG_EXISTS_DONE}"
507 663
508 # if we haven't determined the version yet, we need to 664 # if we haven't determined the version yet, we need to
509 get_version 665 linux-info_get_any_version
510 666
511 # Determine if we really need a .config. The only time when we don't need 667 # Determine if we really need a .config. The only time when we don't need
512 # one is when all of the CONFIG_CHECK options are prefixed with "~". 668 # one is when all of the CONFIG_CHECK options are prefixed with "~".
513 for config in ${CONFIG_CHECK} 669 for config in ${CONFIG_CHECK}
514 do 670 do
521 if [[ ${config_required} == 0 ]]; then 677 if [[ ${config_required} == 0 ]]; then
522 # In the case where we don't require a .config, we can now bail out 678 # In the case where we don't require a .config, we can now bail out
523 # if the user has no .config as there is nothing to do. Otherwise 679 # if the user has no .config as there is nothing to do. Otherwise
524 # code later will cause a failure due to missing .config. 680 # code later will cause a failure due to missing .config.
525 if ! linux_config_exists; then 681 if ! linux_config_exists; then
682 ewarn "Unable to check for the following kernel config options due"
683 ewarn "to absence of any configured kernel sources or compiled"
684 ewarn "config:"
685 for config in ${CONFIG_CHECK}; do
686 local_error="ERROR_${config#\~}"
687 msg="${!local_error}"
688 if [[ "x${msg}" == "x" ]]; then
689 local_error="WARNING_${config#\~}"
690 msg="${!local_error}"
691 fi
692 ewarn " - ${config#\~}${msg:+ - }${msg}"
693 done
694 ewarn "You're on your own to make sure they are set if needed."
695 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
526 return 0 696 return 0
527 fi 697 fi
528 else 698 else
529 require_configured_kernel 699 require_configured_kernel
530 fi 700 fi
531 701
532 einfo "Checking for suitable kernel configuration options..." 702 einfo "Checking for suitable kernel configuration options..."
533 703
534 for config in ${CONFIG_CHECK} 704 for config in ${CONFIG_CHECK}
535 do 705 do
536 # if we specify any fatal, ensure we honor them 706 # if we specify any fatal, ensure we honor them
537 die=1 707 die=1
538 error=0 708 error=0
607 if [[ ${hard_errors_count} > 0 ]]; then 777 if [[ ${hard_errors_count} > 0 ]]; then
608 eerror "Please check to make sure these options are set correctly." 778 eerror "Please check to make sure these options are set correctly."
609 eerror "Failure to do so may cause unexpected problems." 779 eerror "Failure to do so may cause unexpected problems."
610 eerror "Once you have satisfied these options, please try merging" 780 eerror "Once you have satisfied these options, please try merging"
611 eerror "this package again." 781 eerror "this package again."
782 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
612 die "Incorrect kernel configuration options" 783 die "Incorrect kernel configuration options"
613 elif [[ ${soft_errors_count} > 0 ]]; then 784 elif [[ ${soft_errors_count} > 0 ]]; then
614 ewarn "Please check to make sure these options are set correctly." 785 ewarn "Please check to make sure these options are set correctly."
615 ewarn "Failure to do so may cause unexpected problems." 786 ewarn "Failure to do so may cause unexpected problems."
616 else 787 else
617 eend 0 788 eend 0
618 fi 789 fi
790 export LINUX_CONFIG_EXISTS_DONE="${old_LINUX_CONFIG_EXISTS_DONE}"
619} 791}
620 792
621check_zlibinflate() { 793check_zlibinflate() {
622 # if we haven't determined the version yet, we need to 794 # if we haven't determined the version yet, we need to
623 require_configured_kernel 795 require_configured_kernel
636 local DEFLATE 808 local DEFLATE
637 809
638 einfo "Determining the usability of ZLIB_INFLATE support in your kernel" 810 einfo "Determining the usability of ZLIB_INFLATE support in your kernel"
639 811
640 ebegin "checking ZLIB_INFLATE" 812 ebegin "checking ZLIB_INFLATE"
641 getfilevar_isbuiltin CONFIG_ZLIB_INFLATE ${KV_DIR}/.config 813 linux_chkconfig_builtin CONFIG_ZLIB_INFLATE
642 eend $? 814 eend $?
643 [ "$?" != 0 ] && die 815 [ "$?" != 0 ] && die
644 816
645 ebegin "checking ZLIB_DEFLATE" 817 ebegin "checking ZLIB_DEFLATE"
646 getfilevar_isbuiltin CONFIG_ZLIB_DEFLATE ${KV_DIR}/.config 818 linux_chkconfig_builtin CONFIG_ZLIB_DEFLATE
647 eend $? 819 eend $?
648 [ "$?" != 0 ] && die 820 [ "$?" != 0 ] && die
649 821
650 local LINENO_START 822 local LINENO_START
651 local LINENO_END 823 local LINENO_END
694# @FUNCTION: linux-info_pkg_setup 866# @FUNCTION: linux-info_pkg_setup
695# @DESCRIPTION: 867# @DESCRIPTION:
696# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured 868# Force a get_version() call when inherited from linux-mod.eclass and then check if the kernel is configured
697# to support the options specified in CONFIG_CHECK (if not null) 869# to support the options specified in CONFIG_CHECK (if not null)
698linux-info_pkg_setup() { 870linux-info_pkg_setup() {
699 get_version || die "Unable to calculate Linux Kernel version" 871 linux-info_get_any_version
700 872
701 if kernel_is 2 4; then 873 if kernel_is 2 4; then
702 if [ "$( gcc-major-version )" -eq "4" ] ; then 874 if [ "$( gcc-major-version )" -eq "4" ] ; then
703 echo 875 echo
704 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with" 876 ewarn "Be warned !! >=sys-devel/gcc-4.0.0 isn't supported with"

Legend:
Removed from v.1.56  
changed lines
  Added in v.1.91

  ViewVC Help
Powered by ViewVC 1.1.20